<?php

// I used pieces of code and icons I found somewhere by Google... hopefully I didn't break any copirights.

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

function get_agents() // returns names of browser's and OS's icon files, without extension
{
	$useragent = $_SERVER ? $_SERVER['HTTP_USER_AGENT'] : $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
	$ua = strtolower($useragent);
	$ua_browser = 'unknown';
	$ua_os = 'unknown';

	// Browser detection:
	if (strpos($ua, 'epiphany') !== false) $ua_browser = 'epiphany';
	else if (strpos($ua, 'galeon') !== false) $ua_browser = 'galeon';
	else if (strpos($ua, 'safari') !== false) $ua_browser = 'safari';
	else if (strpos($ua, 'konqueror') !== false) $ua_browser = 'konqueror';
	else if (strpos($ua, 'firefox') !== false) $ua_browser = 'firefox';
	else if (strpos($ua, 'firebird') !== false) $ua_browser = 'firebird';
	else if (strpos($ua, 'netscape') !== false) $ua_browser = 'netscape';
	else if (strpos($ua, 'mozilla') !== false && strpos($ua, 'rv:') !== false) $ua_browser = 'mozilla';
	else if (strpos($ua, 'opera') !== false) 
	{
		if (strpos($ua, 'opera mini ') !== false) $ua_browser = 'operamini';
		else $ua_browser = 'opera';
	}
	else if (strpos($ua, 'avant browser') !== false) $ua_browser = 'avant';
	else if (strpos($ua, 'maxthon') !== false || strpos($ua, 'myie') !== false) $ua_browser = 'maxthon';
	else if (strpos($ua, 'slimbrowser') !== false) $ua_browser = 'slimbrowser';
	else if (strpos($ua, 'msie') !== false) 
	{
		if (strpos($ua, 'msie 7.0') !== false) $ua_browser = 'ie7';
		else $ua_browser = 'ie';
	}
	


	// OS detection:
	if (strpos($ua, 'amiga') !== false) $ua_os = 'amiga';
	else if (strpos($ua, 'beos; ') !== false) $ua_os = 'beos';
	else if (strpos($ua, 'freebsd') !== false) $ua_os = 'freebsd';
	else if (strpos($ua, 'linux') !== false)
	{
		if (strpos($ua, 'debian') !== false) $ua_os = 'linuxdebian';
		else if (strpos($ua, 'fedora') !== false) $ua_os = 'linuxfedora';
		else if (strpos($ua, 'gentoo') !== false) $ua_os = 'linuxgentoo';
		else if (strpos($ua, 'kateos') !== false || strpos($ua, 'kate os') !== false) $ua_os = 'linuxkateos';
		else if (strpos($ua, 'knoppix') !== false) $ua_os = 'linuxknoppix';
		else if (strpos($ua, 'kubuntu') !== false) $ua_os = 'linuxkubuntu';
		else if (strpos($ua, 'mandriva') !== false || strpos($ua, 'mandrake') !== false) $ua_os = 'linuxmandriva';
		else if (strpos($ua, 'redhat') !== false || strpos($ua, 'red hat') !== false) $ua_os = 'linuxredhat';
		else if (strpos($ua, 'slackware') !== false) $ua_os = 'linuxslackware';
		else if (strpos($ua, 'suse') !== false) $ua_os = 'linuxsuse';
		else if (strpos($ua, 'ubuntu') !== false) $ua_os = 'linuxubuntu';
		else if (strpos($ua, 'arch') !== false) $ua_os = 'linuxarch';
		else $ua_os = 'linux';
	}
	else if (strpos($ua, 'macosx') !== false || strpos($ua, 'macos') !== false || strpos($ua, 'mac os x') !== false || strpos($ua, 'macintosh') !== false || strpos($ua, 'os=mac') !== false || strpos($ua, 'mac_osx') !== false) $ua_os = 'macos';
	else if (strpos($ua, 'macppc') !== false || strpos($ua, 'mac_ppc') !== false || strpos($ua, 'cpu=ppc;') !== false && strpos($ua, 'os=mac') !== false || strpos($ua, 'macintosh; ppc') !== false || strpos($ua, 'macintosh;') !== false && strpos($ua, 'ppc') !== false || strpos($ua, 'mac_powerpc') !== false) $ua_os = 'macos';
	else if (strpos($ua, 'netbsd') !== false) $ua_os = 'netbsd';
	else if (strpos($ua, 'sunos') !== false || strpos($ua, 'solaris') !== false) $ua_os = 'solaris';
	else if (strpos($ua, 'symbian') !== false) $ua_os = 'symbian';
	else if (strpos($ua, 'unix') !== false) $ua_os = 'unix';
	else if (strpos($ua, 'windows nt 5.0') !== false || strpos($ua, 'windows 2000') !== false || strpos($ua, 'win2000') !== false ||  strpos($ua, 'winnt5.0') !== false) $ua_os = 'windows_98_nt_2000';
	else if (strpos($ua, 'windows 95') !== false || strpos($ua, 'win95') !== false) $ua_os = 'windows_98_nt_2000';
	else if (strpos($ua, 'windows me') !== false || strpos($ua, 'winme') !== false || strpos($ua, 'win9x 4.90') !== false || strpos($ua, 'win 9x 4.90') !== false) $ua_os = 'windows_me';
	else if (strpos($ua, 'windows 98') !== false || strpos($ua, 'win98') !== false) $ua_os = 'windows_98_nt_2000';
	else if (strpos($ua, 'windows nt 5.2') !== false || strpos($ua, 'winnt5.2') !== false) $ua_os = 'windows_98_nt_2000';
	else if (strpos($ua, 'windows nt 5.1') !== false || strpos($ua, 'windows xp 5.1') !== false || strpos($ua, 'windows xp') !== false || strpos($ua, 'winxp') !== false || strpos($ua, 'winnt5.1') !== false || strpos($ua, 'cygwin_nt-5.1') !== false) $ua_os = 'windows_xp_2003';
	else if (strpos($ua, 'windows nt 6.0') !== false || strpos($ua, 'winnt6.0') !== false) $ua_os = 'windows_vista';
	else if (strpos($ua, 'windows nt 4.0') !== false || strpos($ua, 'winnt4.0') !== false || strpos($ua, 'winnt') !== false || strpos($ua, 'windows nt') !== false) $ua_os = 'windows_98_nt_2000';
	else if (strpos($ua, 'windows') !== false || strpos($ua, 'win') !== false) $ua_os = 'windows_xp_2003';
	else if (strpos($ua, 'macintosh') !== false || strpos($ua, 'mac') !== false) $ua_os = 'macos';


	$res = array($ua_browser,$ua_os);
	
	$res[0] = 'icon_'.ereg_replace('[^a-z0-9_]', '', strtolower($res[0]));
	$res[1] = 'icon_'.ereg_replace('[^a-z0-9_]', '', strtolower($res[1]));
	
	return $res;
}

function make_cool_name($str)
{
	$str = str_replace('icon_','',$str);
	
	switch($str)
	{
		case 'epiphany': return 'Epiphany';
		case 'galeon': return 'Galeon';
		case 'safari': return 'Safari';
		case 'konqueror': return 'Konqueror';
		case 'firefox': return 'Firefox';
		case 'firebird': return 'Firebird';
		case 'netscape': return 'Netscape';
		case 'mozilla': return 'Mozilla';		
		case 'opera': return 'Opera';
		case 'operamini': return 'Opera Mini';
		case 'avant': return 'Avant Browser';
		case 'maxthon': return 'Maxthon / MyIE2';
		case 'slimbrowser': return 'SlimBrowser';
		case 'ie': return 'Internet Explorer';
		
		case 'amiga': return 'Amiga';
		case 'beos': return 'BeOS';
		case 'freebsd': return 'FreeBSD';
		case 'linuxdebian': return 'Linux Debian';
		case 'linuxfedora': return 'Linux Fedora';
		case 'linuxgentoo': return 'Linux Gentoo';
		case 'linuxkateos': return 'Linux KateOS';
		case 'linuxknoppix': return 'Linux Knoppix';
		case 'linuxkubuntu': return 'Linux Kubuntu';
		case 'linuxmandriva': return 'Linux Mandriva';
		case 'linuxredhat': return 'Linux RedHat';
		case 'linuxslackware': return 'Linux Slackware';
		case 'linuxsuse': return 'Linux SuSE';
		case 'linuxubuntu': return 'Linux Ubuntu';
		case 'linuxarch': return 'Linux Arch';
		case 'linux': return 'Linux';
		case 'macos': return 'MacOS';
		case 'netbsd': return 'NetBSD';
		case 'solaris': return 'Solaris';
		case 'symbian': return 'Symbian';
		case 'unix': return 'UNIX';
		case 'windows_98_nt_2000': return 'Windows 9x/NT/2000';
		case 'windows_me': return 'Windows ME';
		case 'windows_xp_2003': return 'Windows XP/2003';
		case 'windows_vista': return 'Winows Vista';
	
		default: return 'Unknown';
	}
}

$plugins->add_hook("datahandler_post_update", "useragent_datahandler_post_update");
$plugins->add_hook("datahandler_post_insert_post", "useragent_datahandler_post_insert_post");
$plugins->add_hook("datahandler_post_insert_thread_post", "useragent_datahandler_post_insert_thread_post");
$plugins->add_hook("admin_index_navigation_end", "useragent_admin_index_navigation_end");
$plugins->add_hook("admin_index_start", "useragent_admin_index_start");
$plugins->add_hook("postbit", "useragent_postbit");

function useragent_info()
{
	return array(
		"name"			=> "User Agent",
		"description"	=> 'Shows icons and stats informing about poster\'s operating system and browser. <b>Do not forget about $post[\'icon_os\'] and $post[\'icon_browser\'] in your templates.</b>',
		"website"		=> "http://mybboard.pl/",
		"author"		=> "bryn",
		"authorsite"	=> "",
		"version"		=> "1.2",
	);
}

function useragent_activate()
{
	global $db;
	
	// we create new columns unless they have already been created
	
	$already_there = false;	
	$query = $db->query("SHOW FIELDS FROM ".TABLE_PREFIX."posts");	
	while($field = $db->fetch_array($query))
	{
		if(($field['Field'] == 'browser')||($field['Field'] == 'system'))
		{
			$already_there = true;
		}
	}
	
	if (!$already_there) $query = $db->query("ALTER TABLE ".TABLE_PREFIX."posts ADD `system` VARCHAR( 32 ) DEFAULT 'icon_unknown' NOT NULL , ADD `browser` VARCHAR( 32 ) DEFAULT 'icon_unknown' NOT NULL");

}
function useragent_deactivate()
{
	/*
	DO NOT UNCOMMENT THIS
	unless you want the useragent logs to be pruned during deactivation!
	
	global $db;

	$query = $db->query("ALTER TABLE ".TABLE_PREFIX."posts DROP `system` , DROP `browser`");
	*/
}

function useragent_datahandler_post_update($it)
{
	$ua = get_agents();
	
	$it->post_update_data['browser'] = $ua[0];
	$it->post_update_data['system'] = $ua[1];
	
	return $it;
}

function useragent_datahandler_post_insert_post($it)
{
	$ua = get_agents();
	
	$it->post_update_data['browser'] = $ua[0];
	$it->post_update_data['system'] = $ua[1];
	
	$it->post_insert_data['browser'] = $ua[0];
	$it->post_insert_data['system'] = $ua[1];
	
	return $it;
}

function useragent_datahandler_post_insert_thread_post($it)
{
	$ua = get_agents();
	
	$it->post_insert_data['browser'] = $ua[0];
	$it->post_insert_data['system'] = $ua[1];
	
	return $it;
}

function useragent_postbit($it)
{
	if($it['browser']!='') $it['icon_browser'] = '<img src="images/useragent/'.$it['browser'].'.gif" alt="'.make_cool_name($it['browser']).'" title="Post written using: '.make_cool_name($it['browser']).'" />';
	if($it['system']!='') $it['icon_os'] = '<img src="images/useragent/'.$it['system'].'.gif" alt="'.make_cool_name($it['system']).'" title="Post written using: '.make_cool_name($it['system']).'" />';
}

function useragent_admin_index_navigation_end()
{
	global $menu;
	$menu[130]['items'][40] = array("title" => "Browsers and Systems", "url" => "index.php?".SID."&amp;action=useragent");
}

function useragent_admin_index_start()
{
	global $mybb;
	global $db;
	
	if ($mybb->input['action']=='useragent')
	{
		$query = $db->query('SELECT DISTINCT browser FROM '.TABLE_PREFIX.'posts ORDER BY browser');
		
		cpheader();
		
		starttable();
		tableheader('Browsers','',2);
		echo "<tr>\n";
		echo "<td class=\"subheader\" align=\"left\">Browser</td>\n";
		echo "<td class=\"subheader\" align=\"left\">Posts written using it</td>\n";
		echo "</tr>\n";
		while ($res = $db->fetch_array($query))
		{
			$bgcolor = getaltbg();
			$count = $db->query('SELECT count(browser) FROM '.TABLE_PREFIX.'posts WHERE browser=\''.$res['browser'].'\'');
			$count = $db->fetch_array($count);
			echo "<tr>\n";
			echo "<td class=\"$bgcolor\" align=\"left\">".make_cool_name($res['browser'])."</td>";
			echo "<td class=\"$bgcolor\" align=\"left\">".$count['count(browser)']."</td>";
			echo "</tr>\n";
		}
		endtable();
		
		$query = $db->query('SELECT DISTINCT system FROM '.TABLE_PREFIX.'posts ORDER BY system');
		
		starttable();
		tableheader('Operating Systems','',2);
		echo "<tr>\n";
		echo "<td class=\"subheader\" align=\"left\">Operating System</td>\n";
		echo "<td class=\"subheader\" align=\"left\">Posts written using it</td>\n";
		echo "</tr>\n";
		while ($res = $db->fetch_array($query))
		{
			$bgcolor = getaltbg();
			$count = $db->query('SELECT count(system) FROM '.TABLE_PREFIX.'posts WHERE system=\''.$res['system'].'\'');
			$count = $db->fetch_array($count);
			echo "<tr>\n";
			echo "<td class=\"$bgcolor\" align=\"left\">".make_cool_name($res['system'])."</td>";
			echo "<td class=\"$bgcolor\" align=\"left\">".$count['count(system)']."</td>";
			echo "</tr>\n";
		}
		endtable();
		
		cpfooter();
	}
}
?>
